Updates from royk to safe_asterisk (#5207) Thanks!
[asterisk/asterisk.git] / contrib / scripts / safe_asterisk
old mode 100755 (executable)
new mode 100644 (file)
index ad4ba12..f402969
@@ -1,22 +1,98 @@
 #!/bin/sh
-TTY=9                  # TTY (if you want one) for Asterisk to run on
-CONSOLE=yes            # Whether or not you want a console
-NOTIFY=                        # Who to notify about crashes
+# vim:textwidth=80:tabstop=4:shiftwidth=4:smartindent:autoindent
+
+CLIARGS="$*"                           # Grab any args passed to safe_asterisk
+TTY=9                                          # TTY (if you want one) for Asterisk to run on
+CONSOLE=yes                                    # Whether or not you want a console
+#NOTIFY=ben@alkaloid.net       # Who to notify about crashes
+MACHINE=`hostname`                     # To specify which machine has crashed when getting the mail
+DUMPDROP=/tmp
+SLEEPSECS=5
+ASTSBINDIR=__ASTERISK_SBIN_DIR__
+
+# comment this line out to have this script _not_ kill all mpg123 processes when
+# asterisk exits
+KILLALLMPG123=1
+
+# run asterisk with this priority
+PRIORITY=-19
+
+# set system filemax on supported OSes if this variable is set
+# SYSMAXFILES=262144
+
+# set max files open with ulimit. On linux systems, this will be automatically
+# set to the system's maximum files open devided by two, if not set here.
+# MAXFILES=32768
+
+# since we're going to change priority and open files limits, we need to be
+# root. if running asterisk as other users, pass that to asterisk on the command
+# line.
+# if we're not root, fall back to standard everything.
+if [ `id -u` != 0 ]
+then
+       echo "Ops. I'm not root. Falling back to standard prio and file max." >&2
+       echo "This is NOT suitable for large systems." >&2
+       PRIORITY=0
+else
+       if `echo $OSTYPE | grep linux 2>&1 > /dev/null `
+       then
+               # maximum number of open files is set to the system maximum divided by two if
+               # MAXFILES is not set.
+               if [ "$MAXFILES" = "" ]
+               then
+                       # just check if file-max is readable
+                       if [ -r /proc/sys/fs/file-max ]
+                       then
+                               MAXFILES=$(( `cat /proc/sys/fs/file-max` / 2 ))
+                       fi
+               fi
+               SYSCTL_MAXFILES="fs.file-max"
+       elif `echo $OSTYPE | grep darwin 2>&1 > /dev/null `
+       then
+               SYSCTL_MAXFILES="kern.maxfiles"
+       fi
+
+
+       if [ "$SYSMAXFILES" != "" ]
+       then
+               if [ "$SYSCTL_MAXFILES" != "" ]
+               then
+                       sysctl -w $SYSCTL_MAXFILES=$SYSMAXFILES
+               fi
+       fi
+
+       # set the process's filemax to whatever set above
+       ulimit -n $MAXFILES
+
+fi
+
+#
+# Let Asterisk dump core
+#
+ulimit -c unlimited
+
 #
 # Don't fork when running "safely"
 #
 ASTARGS=""
 if [ "$TTY" != "" ]; then
-       ASTARGS="${ASTARGS} -vvv"
+       if [ -c /dev/tty${TTY} ]; then
+               TTY=tty${TTY}
+       elif [ -c /dev/vc/${TTY} ]; then
+               TTY=vc/${TTY}
+       else
+               echo "Cannot find your TTY (${TTY})" >&2
+               exit 1
+       fi
+       ASTARGS="${ASTARGS} -vvvg"
        if [ "$CONSOLE" != "no" ]; then
                ASTARGS="${ASTARGS} -c"
        fi
 fi
-
-#
-# Let Asterisk dump core
-#
-ulimit -c unlimited
+if [ ! -w ${DUMPDROP} ]; then  
+       echo "Cannot write to ${DUMPDROP}" >&2
+       exit 1
+fi
 
 #launch_asterisk()
 #{
@@ -27,13 +103,15 @@ run_asterisk()
        while :; do 
 
                if [ "$TTY" != "" ]; then
-                       stty sane < /dev/tty${TTY}
-                       asterisk ${ASTARGS} >& /dev/tty${TTY} < /dev/tty${TTY}
+                       cd /tmp
+                       stty sane < /dev/${TTY}
+                       nice -n $PRIORITY ${ASTSBINDIR}/asterisk ${CLIARGS} ${ASTARGS} >& /dev/${TTY} < /dev/${TTY}
                else
-                       asterisk ${ASTARGS}
+                       cd /tmp
+                       nice -n $PRIORITY ${ASTSBINDIR}/asterisk ${CLIARGS} ${ASTARGS}
                fi
                EXITSTATUS=$?
-               #echo "Asterisk ended with exit status $EXITSTATUS"
+               echo "Asterisk ended with exit status $EXITSTATUS"
                if [ "$EXITSTATUS" = "0" ]; then
                        # Properly shutdown....
                        echo "Asterisk shutdown normally."
@@ -42,14 +120,29 @@ run_asterisk()
                        let EXITSIGNAL=EXITSTATUS-128
                        echo "Asterisk exited on signal $EXITSIGNAL."
                        if [ "$NOTIFY" != "" ]; then
-                               echo "Asterisk exited on signal $EXITSIGNAL.  Might want to take a peek." | \
+                               echo "Asterisk on $MACHINE exited on signal $EXITSIGNAL.  Might want to take a peek." | \
                                mail -s "Asterisk Died" $NOTIFY
                        fi
+                       if [ -f /tmp/core ]; then
+                               mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
+                       fi
                else
-                       echo "Asterisk died with code $EXITSTATUS.  Aborting."
-                       exit 0
+                       if [ "${EXITSTATUS}" = "0" ]; then
+                               echo "Asterisk ended normally.  Aborting."
+                               exit 0
+                       else
+                               echo "Asterisk died with code $EXITSTATUS."
+                               if [ -f /tmp/core ]; then
+                                       mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
+                               fi
+                       fi
                fi
                echo "Automatically restarting Asterisk."
+               sleep $SLEEPSECS
+               if [ $KILLALLMPG123 ]
+               then
+                       killall -9 mpg123
+               fi
        done
 }